program ngit_bootstrap_application;
{$mode delphi}{$H+}
//}
uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}

  Classes, ezEngine, ezMSTechSupport, IdBaseComponent, IdComponent, IdTCPServer,
  IdCustomHTTPServer, IdHTTPServer, IdContext, IdCustomTCPServer,
  IdSocketHandle, SysUtils, unit_controller, unit_ngitcostants, Crt, LCLType
  ;

type
  TNGITBootstrapApplication = class(TObject)
  protected
    IdHTTPServer1: TIdHTTPServer;
    FHTMLDir: string;
    FTemplate: string;
    //
    procedure Ask(ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);

    procedure IdHTTPServer1SessionStart(Sender: TIdHTTPSession);
    procedure IdHTTPServer1SessionEnd(Sender: TIdHTTPSession);
    procedure IdHTTPServer1CommandGet(AContext: TIdContext;
      ARequestInfo: TIdHTTPRequestInfo;
      AResponseInfo: TIdHTTPResponseInfo);

  public
   constructor Create;
   destructor Destroy; override;
  end;

constructor TNGITBootstrapApplication.Create;
var
  b : TIdSocketHandle;
begin
  IP_ADDR := '127.0.0.1';

  inherited Create;

  idhttpserver1 := TIdHTTPServer.Create;
  b:=idhttpserver1.Bindings.Add;
  b.IP:=IP_ADDR;
  b.IP:=IP_ADDR;
  b.port:=PORT;
  idhttpserver1.DefaultPort := 25000;
  idhttpserver1.AutoStartSession := True;
  idhttpserver1.ServerSoftware := 'NGIT Bootstrap Application';
  idhttpserver1.SessionTimeOut := 600000;
  idhttpserver1.OnSessionStart := IdHTTPServer1SessionStart;
  idhttpserver1.OnSessionEnd := IdHTTPServer1SessionEnd;
  idhttpserver1.OnCommandGet := IdHTTPServer1CommandGet;
  idhttpserver1.SessionState := True;
  idhttpserver1.active:=true;
  FHTMLDir := ExtractFilePath(ParamStr(0)) + 'HTML';
  with TFileStream.Create(includetrailingpathdelimiter(FHTMLDir)+ 'index.html',   fmOpenRead) do try
    SetLength(FTemplate, Size);
    ReadBuffer(FTemplate[1], Size);
  finally Free; end;
end;

destructor TNGITBootstrapApplication.Destroy;
begin
  FreeAndNil(idhttpserver1);
  inherited Destroy;
end;
procedure TNGITBootstrapApplication.IdHTTPServer1SessionStart(Sender: TIdHTTPSession);
begin
  Sender.Content.AddObject('index', TEZEngine.Create(nil));
end;

procedure TNGITBootstrapApplication.IdHTTPServer1SessionEnd(Sender: TIdHTTPSession);
begin
  TEZEngine(Sender.Content.Objects[0]).Free;
end;

procedure TNGITBootstrapApplication.IdHTTPServer1CommandGet(AContext: TIdContext;
      ARequestInfo: TIdHTTPRequestInfo;
      AResponseInfo: TIdHTTPResponseInfo);
var
  LFilename: string;
  NGITController: TNGITController;
begin

       try
          try

            LFilename := ARequestInfo.Document;
            //writeln('A: ' + LFilename);  //<-- ogni file richiesto dal browser

            NGITController:=TNGITController.Create(IdHTTPServer1,AContext,ARequestInfo,AResponseInfo, LFilename, FHTMLDir);
            NGITController.Free;

          finally
                 //codice da effettuare a fine procedura sia che va bene il codice sopra sia che il codice ha sollevato un'eccezzione
         end;
       except
             on E: Exception do
             begin

                 writeln('Err: ' + E.Message);
                //codice da eseguire solo se si verifica un eccezzione

             end;
       end;



end;

procedure TNGITBootstrapApplication.Ask(ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
var
  s: string;
  LEliza: TEZEngine;
  LPersonality: string;
  LResponse: string;
  LSound: string;
  LQuestion: string;
begin
  LResponse := '';
  LSound    := '';
  //writeln('B: ' + ARequestInfo.Session.SessionID); <-- id sessione
  LEliza := TEZEngine(ARequestInfo.Session.Content.Objects[0]);
  LPersonality := Trim(ARequestInfo.Params.Values['Personality']);
  if LPersonality <> '' then begin
    LEliza.SetPersonality(LPersonality);
  end else begin
    LQuestion := Trim(ARequestInfo.Params.Values['Thought']);
    if LQuestion <> '' then begin
      LResponse := LEliza.TalkTo(LQuestion, LSound);
    end;
  end;
  if LEliza.Done then begin
    AResponseInfo.ContentText := LResponse;
  end else begin
    s := FTemplate;
    s := StringReplace(s, '{%RESPONSE%}', LResponse, []);
    if LSound <> '' then begin
      // I cannot distibute the wav files, they are from a commercial game, but I use
      // them when showing the demo live.
      if FileExists(FHTMLDir + '\' + LSound) then begin
        LSound := '<BGSOUND SRC=' + LSound + '.wav>';
      end else begin
        LSound := '';
      end;
    end;
    s := StringReplace(s, '{%SOUND%}', LSound, []);
    AResponseInfo.ContentText := s;
  end;
end;

var
  GProg : TNGITBootstrapApplication;
  ch : char;
begin
  GProg := TNGITBootstrapApplication.Create;
  try
    WriteLn('NGIT Bootstrap Application now aviable');
    WriteLn('');
    WriteLn(HTTP_TYPE + '://' + IP_ADDR + ':' + IntToStr(PORT) + '/index.html');
    WriteLn('');

    writeln('Press Esc for Quit');
    repeat
      ch:=ReadKey;
    until ord(ch)=VK_ESCAPE {Esc}

  finally
   FreeAndNil(GProg);
  end;
end.

